<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\IntegracaoCpService;

class IntegracaoCpController extends SMCrud {
    protected $integracaoService;
    
    public function __construct ($crudService, $environment, IntegracaoCpService $integracaoService) {
        parent::__construct($crudService, $environment);
        $this->integracaoService = $integracaoService;
    }
    
    /**
     * Gera uma parcela para cobranças de serviços que extrapolam o valor do contrato
    **/
    public function gerarParcelaExtra(Request $request, Response $response) {
        try {
            $rows    = $request->getDataSet()->getRows()[0];
            $retorno = $this->integracaoService->gerarParcelaExtra($rows);
            $response->addDataSet(new DataSet("NRFATURACONT", array("NRFATURACONT" => $retorno)));
        } catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>